<?php

namespace FiloBlu\Design\ConfigProvider;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Store\Model\ScopeInterface;

class CheckoutConfigProvider implements ConfigProviderInterface {

    const CONFIG_PATH_AUTO_COMPLETE_ENABLED = 'filoblu_checkoutextend_section/auto_complete/enabled';
    const CONFIG_PATH_AUTO_COMPLETE_API_KEY = 'filoblu_checkoutextend_section/auto_complete/api_key';
    const CONFIG_PATH_CMS_BLOCK_CUSTOM_DUTIES_ENABLED = 'filoblu_checkoutextend_section/cms_block_custom_duties_disclaimer/enabled';
    const CONFIG_PATH_BACK_TO_CART_ENABLED = 'filoblu_checkoutextend_section/back_to_cart/enabled';

    /**
     * @var ScopeConfigInterface
     */
    private $scopeConfig;
    private $assetRepo;

    /**
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(ScopeConfigInterface $scopeConfig, \Magento\Framework\View\Asset\Repository $assetRepo) {
        $this->scopeConfig = $scopeConfig;
        $this->assetRepo = $assetRepo;
    }

    /**
     * @return array
     */
    public function getConfig() {

        $_intlTelInput = $this->scopeConfig->getValue('filoblu_design_section/js_library/intlTelInput_enabled', ScopeInterface::SCOPE_STORE) && $this->scopeConfig->getValue('filoblu_design_section/js_library/intlTelInput_enableOnCheckout', ScopeInterface::SCOPE_STORE);

        if ($_intlTelInput) {
            return [
                'intlTelInput' => [
                    'geolocation' => $this->scopeConfig->getValue('filoblu_design_section/js_library/intlTelInput_geolocation', ScopeInterface::SCOPE_STORE),
                    'validation' => $this->scopeConfig->getValue('filoblu_design_section/js_library/intlTelInput_validation', ScopeInterface::SCOPE_STORE),
                    'utilsScriptUrl' => $this->assetRepo->getUrl('FiloBlu_Design::js/intlTelInput/js/utils.js')
                ]
            ];
        } else {
            return [];
        }
    }

}
